#include "os.h"
#include "s_defines.h"
#include "match_ext.h"
#include "s_externs.h"

#include "rusnet_cmds_ext.h"

int m_codepage(cptr, sptr, parc, parv)
aClient *cptr;
aClient *sptr;
int     parc;
char    *parv[];
{
    int  i;
    FILE *fp;

    if (parc < 2) return -1;

    for (i=0; i<strlen(parv[1]); i++) parv[1][i]=toupper(parv[1][i]); 
 
    rusnet_changecodepage(sptr, parv[1], parv[0]);

    return 0;    
}

int m_force(cptr, sptr, parc, parv)
aClient *cptr;
aClient *sptr;
int     parc;
char    *parv[];
{
    aClient *acptr, *workptr = NULL, *workptr2;
    char    *pparv[3];
    int     i;
    FILE    *fp;

    if (parc < 3)
	return -1;

    if (!IsServer(cptr)) return -1;

    /* Check if parv[2] is a registered nickname */
    workptr = NULL;
    if (find_client( parv[2], workptr) != NULL)
    {
	return -1; /* Could not force nickchange, new nick is registered */
    }

    /* Check if parv[1] exists and local */

    workptr = NULL;
    if ((workptr2=find_client( parv[1], workptr)) == NULL)
    {
       return -1; /* No such user */
    }

    if (MyConnect(workptr2))
    {  
        /* Do nickchange procedure */

        pparv[0]= parv[1];
        pparv[1]= parv[2];
        pparv[2]=NULL;
        m_nick(workptr2, workptr2, 2, pparv);
    }
    else
    {
      /* Propagate FORCE to other servers */
      for (i=fdas.highest; i>=0; i--)
      {
        if (!(acptr = local[fdas.fd[i]]) || !IsServer(acptr) ||
            acptr == cptr || IsMe(acptr))
            continue;

           /* This is a mandatory while RusNet is operating in mixed mode */
	   if (acptr->rusnet_proto != RUSNET_1_4)
              continue; 

           sendto_one(acptr,"FORCE %s %s", parv[1], parv[2]);
      }
    }
}

