#include "os.h"
#include "s_defines.h"
#include "match_ext.h"

#include "rusnet.h"

unsigned char logging_enabled = 1;
char          logfile_name[256];
char          config_prefix[256];

void update_matchtables()
{
     int    i;

     for (i=0xc1; i<=0xdf; i++)
     {
	  touppertab[i] = i+0x20;
          tolowertab[i+0x20] = i;
	  char_atribs[i] = char_atribs[i+0x20] = PRINT|ALPHA;
     }

     touppertab[0xa3] = 0xb3; 
     tolowertab[0xb3] = 0xa3;
     char_atribs[0xa3] = char_atribs[0xb3] = PRINT|ALPHA;
}

     

void initialize_rusnet(char *path)
{
     extern unsigned long rusnet_vaddr;
     extern struct rusnet_route *hdr_rusnet_route;

     FILE *finit;
     char s[256];
     int  i,j,k,l;
     char parm[16][64];
     int  ptr;
     char codepage_name[256],intable[256], outtable[256], portnum[16];
     FILE *fp;

     hdr_rusnet_route = NULL; 

     update_matchtables();

     finit = fopen(path, "rt");
     if (finit == NULL)
        return;

     while (fgets(s,250,finit) != NULL)
     {
           l = strlen(s); 
           if (s[l-1] == '\n') s[l-1] = 0; l--;

           if (s[0] == '#') continue;

      /*
       * 
       *    Parsing source line
       *
       */
           i = 0;
           ptr = 0;
           for (j=0; j<16; j++) parm[j][0]=0;

           while (i < l && s[i] != ';')
           {
              while (s[i] == ' ' && i < l) i++;
              parm[ptr][0]=0;
              j = 0;
              while (s[i] != ' ' && i < l && s[i] != ';')
                    parm[ptr][j++] = s[i++];
              parm[ptr++][j]=0;
           }
      /*
       * 
       *    Configure rusnet extensions 
       *
       */

           if (strcmp(parm[0], "logfile") == 0)
           {
                  logging_enabled = 1;
                  strcpy(logfile_name, parm[1]);
           }
           else
           if (strcmp(parm[0], "prefix") == 0)
           {
               strcpy(config_prefix, parm[1]);
           }
	   else
           if (strcmp(parm[0], "codepage") == 0)
           {
               strcpy(codepage_name, parm[1]);
               for (j=0; j<strlen(codepage_name); j++)
                    codepage_name[j]=toupper(codepage_name[j]);


               intable[0]=0; outtable[0]=0; portnum[0]=0;

               for (j = 2; j < ptr; j+=2)
               {

                   if (strcmp(parm[j], "incoming") == 0)
                      strcpy(intable, parm[j+1]);
                   else
                   if (strcmp(parm[j], "outgoing") == 0)
                      strcpy(outtable, parm[j+1]);
                   else
                   if (strcmp(parm[j], "port") == 0)
                      strcpy(portnum, parm[j+1]);
               }
             
               rusnet_codepage_register(portnum, codepage_name, 
                                        intable, outtable);

           }
           else
           if (strcmp(parm[0],"interface") == 0)
	   {
		rusnet_vaddr = inet_addr(parm[1]);
		
           }
	   else
	   if (strcmp(parm[0],"connect") == 0)
	   {
	        if (strcmp(parm[2],"thru") == 0)
	        {
			if (parm[4][0] == 0)
				strcpy(parm[4], "[Unnamed]");

			rusnet_add_route(parm[1],parm[3],parm[4]);
                }
           }
      }

     fclose(finit);
}  

void uninitialise_rusnet(void)
{
     rusnet_codepage_free();
}

